LeetCode 2208. 将数组和减半的最少操作次数:贪心(优先队列)

【LetMeFly】2208.将数组和减半的最少操作次数:贪心(优先队列)

力扣题目链接:https://leetcode.cn/problems/minimum-operations-to-halve-array-sum/

给你一个正整数数组 nums 。每一次操作中,你可以从 nums 中选择 任意 一个数并将它减小到 恰好 一半。(注意,在后续操作中你可以对减半过的数继续执行操作)

请你返回将 nums 数组和 至少 减少一半的 最少 操作数。

示例 1:

复制代码
输入:nums = [5,19,8,1]
输出:3
解释:初始 nums 的和为 5 + 19 + 8 + 1 = 33 。
以下是将数组和减少至少一半的一种方法:
选择数字 19 并减小为 9.5 。
选择数字 9.5 并减小为 4.75 。
选择数字 8 并减小为 4 。
最终数组为 [5, 4.75, 4, 1] ,和为 5 + 4.75 + 4 + 1 = 14.75 。
nums 的和减小了 33 - 14.75 = 18.25 ,减小的部分超过了初始数组和的一半,18.25 >= 33/2 = 16.5 。
我们需要 3 个操作实现题目要求,所以返回 3 。
可以证明,无法通过少于 3 个操作使数组和减少至少一半。

示例 2:

复制代码
输入:nums = [3,8,20]
输出:3
解释:初始 nums 的和为 3 + 8 + 20 = 31 。
以下是将数组和减少至少一半的一种方法:
选择数字 20 并减小为 10 。
选择数字 10 并减小为 5 。
选择数字 3 并减小为 1.5 。
最终数组为 [1.5, 8, 5] ,和为 1.5 + 8 + 5 = 14.5 。
nums 的和减小了 31 - 14.5 = 16.5 ,减小的部分超过了初始数组和的一半, 16.5 >= 31/2 = 16.5 。
我们需要 3 个操作实现题目要求,所以返回 3 。
可以证明,无法通过少于 3 个操作使数组和减少至少一半。

提示:

  • 1 <= nums.length <= 105
  • 1 <= nums[i] <= 107

方法一:贪心(优先队列)

思路很简单,每次将数组中最大的元素减半即可。

具体怎么实现呢?很多编程语言都有"优先队列"。因此我们只需要使用一个大根堆(出队时大元素优先的优先队列),每次将队首元素取出减半并放回即可。

  • 时间复杂度 O ( l e n ( n u m s ) × log ⁡ l e n ( n u m s ) ) O(len(nums)\times \log len(nums)) O(len(nums)×loglen(nums)),操作次数不超过数组长度。
  • 空间复杂度 O ( l e n ( n u m s ) ) O(len(nums)) O(len(nums))

AC代码

C++

cpp 复制代码
class Solution {
public:
    int halveArray(vector<int>& nums) {
        priority_queue<double> pq;
        double s = 0;
        for (int t : nums) {
            pq.push(t);
            s += t;
        }
        double need = s / 2;
        int ans = 0;
        while (need > 0) {
            double thisValue = pq.top();
            pq.pop();
            thisValue /= 2;
            need -= thisValue;
            pq.push(thisValue);
            ans++;
        }
        return ans;
    }
};

Python

python 复制代码
# from typing import List
# import heapq

class Solution:
    def halveArray(self, nums: List[int]) -> int:
        pq = []
        s = 0
        for t in nums:
            heapq.heappush(pq, -t)
            s += t
        need = s / 2
        ans = 0
        while need > 0:
            thisValue = -heapq.heappop(pq)
            thisValue /= 2
            need -= thisValue
            ans += 1
            heapq.heappush(pq, -thisValue)
        return ans

同步发文于CSDN,原创不易,转载请附上原文链接哦~

Tisfy:https://letmefly.blog.csdn.net/article/details/131908685

相关推荐
2601_9603563828 分钟前
2027校招采购岗解析:数学基础如何迁移到需求预测、成本与供应商分析
人工智能·算法
h_a_o777oah1 小时前
【树论】树链剖分:将树形结构转化为线性结构以处理树上路径问题(洛谷 P3384 附C++代码模板)
数据结构·算法·线段树·acm·树链剖分·树论·重链剖分
HEJOO91 小时前
指针的算术运算详解
java·数据结构·算法
Coder-magician1 小时前
《代码随想录》刷题打卡day47:并查集-part01
数据结构·算法·图论
垆边人似月.1 小时前
VLAN 资源池(100~200 分档)
数据结构·算法
潼心1412o2 小时前
C++初阶(长期更新)第6讲:类和对象(下)
开发语言·c++·算法
星光开发者2 小时前
基于决策树随机森林算法的小说推荐系统的设计与实现-计算机毕设【课程设计】78485
vue.js·算法·微信小程序·django·php·课程设计·express
-森屿安年-3 小时前
按身高排序
c++·算法
程序员清风3 小时前
算法与数据结构入门:复杂度、数组与链表
数据结构·算法·链表
无定义_3 小时前
Codeforces Round 1124 (Div. 2)
算法